import com.amazonaws.AmazonClientException;
import com.amazonaws.AmazonServiceException;
import com.amazonaws.ClientConfiguration;
import com.amazonaws.Protocol;
import com.amazonaws.auth.BasicAWSCredentials;
import com.amazonaws.services.s3.AmazonS3;
import com.amazonaws.services.s3.AmazonS3Client;
import com.amazonaws.services.s3.model.*;

import java.io.ByteArrayInputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.net.URL;
import java.net.URLConnection;
import java.nio.charset.StandardCharsets;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import java.util.*;
import java.util.Map.Entry;
public class HS3 {



    public static String getBase64Value(String input){
        Base64.Encoder encoder = Base64.getEncoder();
        String encodedString = encoder.encodeToString(
                input.getBytes(StandardCharsets.UTF_8) );
        return encodedString;
    }

    public static String getMD5Value(String input){
        String md5 = "";
        try{
            MessageDigest md = MessageDigest.getInstance("MD5");
            md.update(input.getBytes());
            byte[] digest = md.digest();
            StringBuffer sb = new StringBuffer();
            for (byte b : digest) {
                sb.append(String.format("%02x", b & 0xff));
            }

            md5 = sb.toString();
        }
        catch (NoSuchAlgorithmException e) {
            System.err.println("I'm sorry, but MD5 is not a valid message digest algorithm");
        }
        return md5;
    }
    //ejh4aTc2ZnE=:d4460e0ab8234909a79eec9203279ded
    //相当于HCP的租户==AWS的Endpoint
    private String endpointName="gic.cnbj01.cdsgss.com";
    //config
    private ClientConfiguration myClientConfig = new ClientConfiguration();
    //aws client
    @SuppressWarnings("unused")
    private AmazonS3 hs3Client=null;
    //用户名和密码
    private String username =getBase64Value("netskill");
    //private String username =getBase64Value("security");
    private String userpwd = getMD5Value("hcp123");
    private String accessKeyID = "OWN3N2Vkhhg=";
    private String secretAccessKeyID = "25bc8b806b47e3bd7fed3543f84eee8b";

    private static String dir="C:/Users/lbin/Documents/HDSSvn/首都在线/testFile/";

    public HS3() {
        myClientConfig.setProtocol(Protocol.HTTP);
        myClientConfig.setSignerOverride("S3SignerType");
        hs3Client = new AmazonS3Client(
                new BasicAWSCredentials(accessKeyID , secretAccessKeyID ), myClientConfig );
        hs3Client.setEndpoint(endpointName);
    }


    public static void main(String[] args) throws IOException {

        //得到版本状态
        //new HS3().getBucketVersion("testnamespace");

        //开启桶的版本
        //new HS3().setVersionOnOff("testnamespace","Suspended");

        //创建桶
        //new HS3().createBucket("testnamespace");
        System.out.printf("---------------------------------------");
        //列出所有桶
        new HS3().listBuckets();

        //检测桶是否存在
        //new HS3().checkBucketExist("testnamespace");

        //得到桶的的ACL
        //new HS3().getACLFromBucket("testnamespace");

        //设置桶的ACL
        //new HS3().setACLForBucket("testnamespace");

        //创建对象

        new HS3().createObjectByUrl("zhouzhou","test.jpeg","https://ss0.baidu.com/6ONWsjip0QIZ8tyhnq/it/u=1371255168,3890406440&fm=173&app=25&f=JPEG?w=600&h=360&s=96397C87140274E0582B51B20300F018");

        //new HS3().createObject("testnamespace", "HS3.java", dir+"HS3.java");
        System.out.printf("---------------------------------------");
        //new HS3().createObject("testnamespace", "北京/北京-朝阳.txt", dir+"北京-朝阳.txt");
        //new HS3().createObject("testnamespace", "北京/北京-东城.txt", dir+"北京-东城.txt");
        //new HS3().createObject("testnamespace", "北京/北京-通州.txt", dir+"北京-通州.txt");
        //new HS3().createObject("testnamespace", "北京/北京-西城.txt", dir+"北京-西城.txt");
        //new HS3().createObject("testnamespace", "上海/上海-内环.txt", dir+"上海-内环.txt");
        //new HS3().createObject("testnamespace", "上海/上海-浦东.txt", dir+"上海-浦东.txt");
        //new HS3().createObject("testnamespace", "上海/上海-浦西.txt", dir+"上海-浦西.txt");

        //创建目录
        //new HS3().createDir("testnamespace", "天津/");

        //列出对象
        //new HS3().listObjects("testnamespace");
        System.out.printf("---------------------------------------");

        //列出根目录对象
        //new HS3().listObjectsByDir("testnamespace", "");
        System.out.printf("---------------------------------------");
        //列出目录“北京/下的对象
        //new HS3().listObjectsByDir("testnamespace","北京/");
        //列出目录“北京/123/”下的对象
        //new HS3().listObjectsByDir("testnamespace","北京/123/");

        //列出对象，并分页
        //new HS3().listObjectsByDirPagination("testnamespace","北京/",2,"");
        //new HS3().listObjectsByDirPagination("testnamespace","北京/",2,"北京/123/");
        //new HS3().listObjectsByDirPagination("testnamespace","北京/",2,"北京/北京-朝阳.txt");

        //检测对象目录是否存在
        //new HS3().checkObject("testnamespace", "上海/");
        //new HS3().checkObject("testnamespace", "中国.txt");

        //创建对象，附件元数据
		/*
		//元数据信息
		ObjectMetadata metadata = new ObjectMetadata();
		metadata.addUserMetadata("xingMing", "netskill");
		new HS3().createObjectAndMetadata("testnamespace",
				"test.txt", dir+"test.txt",metadata);
		*/


        //得到对象元数据
        //new HS3().getObjectMetadata("testnamespace", "树状结构.xlsx");


        //更新对象元数据
		/*
		ObjectMetadata metadata = new ObjectMetadata();
		metadata.addUserMetadata("tel", "13439988718");
		new HS3().updateObjectMetadata("testnamespace", "test.txt",metadata);

		*/

        //删除对象元数据
        //new HS3().deleteObjectMetadata("testnamespace", "test.txt");

        //删除对象
        //new HS3().deleteObject("testnamespace","组织架构.xlsx");

        //删除多个对象，不指定版本
		/*
		new HS3().deleteObjects("testnamespace","树状结构.xlsx"
				,"树状结构 - 副本.xlsx");
			*/

        //列出对象各版本
        //new HS3().listVersions("testnamespace","树状结构.xlsx");

        //删除对象的各版本
        //new HS3().deleteObjectByVersion("testnamespace","树状结构.xlsx");

        //删除空目录
        //new HS3().deleteDir("testnamespace","123/");


        //对象复制
        //new HS3().copyObject("testnamespace","中国.txt","testnamespace","中国CHINA.TXT");

        //读取文件写到本地
		/*
		try {
			new HS3().getObject("testnamespace","树状结构 - 副本.xlsx",
					"C:/Users/lbin/Documents/HDSSvn/首都在线/testFile/树状结构 - 副本.xlsx");
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}*/

        //分别读取每个版本，保存到本地
		/*
		try {
			new HS3().getObjectVersions("testnamespace","树状结构 - 副本.xlsx",
					"C:/Users/lbin/Documents/HDSSvn/首都在线/testFile/");
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}*/


        //读取对象，分片读取
		/*
		try {
			new HS3().getObjectByRange("testnamespace","树状结构 - 副本.xlsx",
						"C:/Users/lbin/Documents/HDSSvn/首都在线/testFile/树状结构 - 副本.xlsx"
					, 0, 2000);
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}*/

        //将某个对象授权给某个用户
		/*
		ArrayList<String> aclList = new ArrayList<String>();
		aclList.add("READ");
		new HS3().setObjectACL("testnamespace","树状结构 - 副本.xlsx",
				aclList,"83813c7e-dd96-4572-8556-813b6a997ff7");

		*/

        //得到对象的ACL
        //new HS3().getObjectACL("testnamespace","树状结构 - 副本.xlsx");

        //将对象的所有版本授权给某个用户
		/*
		ArrayList<String> aclList = new ArrayList<String>();
		aclList.add("READ");
		new HS3().setObjectVersionACL("testnamespace","树状结构 - 副本.xlsx",
				aclList,"83813c7e-dd96-4572-8556-813b6a997ff7");
				*/

        //得到对象所有版本的ACL
        //new HS3().getObjectVersionACL("testnamespace","树状结构 - 副本.xlsx");


        //取消用户当前授权，并重新授权
//		ArrayList<String> aclList = new ArrayList<String>();
//		aclList.add("WRITE");
//		new HS3().clearObjectVersionACL("testnamespace","树状结构 - 副本.xlsx",aclList,
//				"83813c7e-dd96-4572-8556-813b6a997ff7");
    }

    public void createObjectByUrl(String bucketName, String objectKey, String urlStr) throws IOException {
        URL url = new URL(urlStr);
        URLConnection connection = url.openConnection();
        connection.setDoOutput(true);
        Long contentLength = connection.getContentLengthLong();

        ObjectMetadata metadata = new ObjectMetadata();
        metadata.setContentLength(contentLength);
        try {
            hs3Client.putObject(new PutObjectRequest(bucketName, objectKey, connection.getInputStream(), metadata));

        } catch (AmazonServiceException ase) {
            System.out.println("Error Message:    " + ase.getMessage());
            System.out.println("HTTP Status Code: " + ase.getStatusCode());
            System.out.println("AWS Error Code:   " + ase.getErrorCode());
            System.out.println("Error Type:       " + ase.getErrorType());
            System.out.println("Request ID:       " + ase.getRequestId());
        } catch (AmazonClientException ace) {
            System.out.println("Error Message: " + ace.getMessage());
        } finally {
            if (connection.getInputStream() != null) {
                connection.getInputStream().close();
            }
        }
    }


    /**
     * 取消用户当前授权，并重新授权
     * @param bucketName
     * @param objectKey
     * @param ACLList
     * @param userId
     */
    public void clearObjectVersionACL(String bucketName,
                                      String objectKey,List<String> ACLList,String userId)
    {
        //得到现有对象的ACL
        AccessControlList list = hs3Client.getObjectAcl(bucketName, objectKey);
        //清除所有授权信息
        list.getGrants().clear();
        //为某个用户授权，需要指定用户的ID
        CanonicalGrantee grantee =new		CanonicalGrantee(userId);

        if(ACLList!=null)
            //为用户重新授权
            for(String acl:ACLList)
            {
                if(acl.equals("READ"))
                    list.grantPermission(grantee, Permission.Read);
                else if(acl.equals("READ_ACP"))
                    list.grantPermission(grantee, Permission.ReadAcp);
                else if(acl.equals("WRITE"))
                    list.grantPermission(grantee, Permission.Write);
                else if(acl.equals("WRITE_ACP"))
                    list.grantPermission(grantee, Permission.WriteAcp);
                else if(acl.equals("FULL_CONTROL"))
                    list.grantPermission(grantee, Permission.FullControl);
            }

        //得到对象的所有版本
        List<S3VersionSummary> versions = listVersions(bucketName, objectKey);
        for(S3VersionSummary v:versions)
        {
            //为每个版本分别授权
            hs3Client.setObjectAcl(bucketName, objectKey,v.getVersionId(), list);
        }

    }


    /**
     * 得到对象所有版本的ACL
     * @param bucketName 桶名
     * @param objectKey 对象key
     */
    public void getObjectVersionACL(String bucketName,
                                    String objectKey)
    {
        //得到对象的所有版本
        List<S3VersionSummary> versions = listVersions(bucketName, objectKey);
        for(S3VersionSummary v :versions)
        {
            System.out.println("version id  = "+v.getVersionId());
            //得到指定版本对象的ACL
            AccessControlList list = hs3Client.getObjectAcl(bucketName,
                    objectKey,v.getVersionId()
            );
            //列出授权信息
            Set<Grant> grants = list.getGrants();
            //显示授权信息
            for(Grant g:grants)
            {
                System.out.println("id = "+g.getGrantee().getIdentifier());
                System.out.println(" permission = "+g.getPermission().toString());
            }
        }
    }


    /**
     * 得到对象的ACL
     * @param bucketName 桶名
     * @param objectKey 对象key
     */
    public void getObjectACL(String bucketName,
                             String objectKey)
    {
        //得到现有对象的ACL
        AccessControlList list = hs3Client.getObjectAcl(bucketName, objectKey);
        //列出授权信息
        Set<Grant> grants = list.getGrants();
        //显示授权信息
        for(Grant g:grants)
        {
            System.out.println("id = "+g.getGrantee().getIdentifier());
            System.out.println(" permission = "+g.getPermission().toString());
        }
    }


    /**
     *将某个对象授权给某个用户
     *此方法将作用于对象的所有版本
     * @param bucketName 桶名
     * @param objectKey  对象key
     * @param ACL 可以设置的ACL值
     *  值 READ
    值 READ_ACP
    值 WRITE
    值 WRITE_ACP
    值 FULL_CONTROL
     @param userId 要授权的用户ID
     */
    public void setObjectVersionACL(String bucketName,
                                    String objectKey,List<String> ACLList,String userId)
    {
        //得到现有对象的ACL
        AccessControlList list = new AccessControlList();
        list = hs3Client.getObjectAcl(bucketName, objectKey);

        //为某个用户授权，需要指定用户的ID
        CanonicalGrantee grantee =new		CanonicalGrantee(userId);

        for(String acl:ACLList)
        {
            if(acl.equals("READ"))
                list.grantPermission(grantee, Permission.Read);
            else if(acl.equals("READ_ACP"))
                list.grantPermission(grantee, Permission.ReadAcp);
            else if(acl.equals("WRITE"))
                list.grantPermission(grantee, Permission.Write);
            else if(acl.equals("WRITE_ACP"))
                list.grantPermission(grantee, Permission.WriteAcp);
            else if(acl.equals("FULL_CONTROL"))
                list.grantPermission(grantee, Permission.FullControl);
        }

        //得到对象的所有版本
        List<S3VersionSummary> versions = listVersions(bucketName, objectKey);
        for(S3VersionSummary v:versions)
        {
            //为每个版本分别授权
            hs3Client.setObjectAcl(bucketName, objectKey,v.getVersionId(), list);
        }

    }


    /**
     *将某个对象授权给某个用户
     *此方法仅作用于对象的当前版本
     * @param bucketName 桶名
     * @param objectKey  对象key
     * @param ACL 可以设置的ACL值
     *  值 READ
    值 READ_ACP
    值 WRITE
    值 WRITE_ACP
    值 FULL_CONTROL
     @param userId 要授权的用户ID
     */
    public void setObjectACL(String bucketName,
                             String objectKey,List<String> ACLList,String userId)
    {
        //得到现有对象的ACL
        AccessControlList list = new AccessControlList();
        list = hs3Client.getObjectAcl(bucketName, objectKey);


        //为某个用户授权，需要指定用户的ID
        CanonicalGrantee grantee =new		CanonicalGrantee(userId);

        for(String acl:ACLList)
        {
            if(acl.equals("READ"))
                list.grantPermission(grantee, Permission.Read);
            else if(acl.equals("READ_ACP"))
                list.grantPermission(grantee, Permission.ReadAcp);
            else if(acl.equals("WRITE"))
                list.grantPermission(grantee, Permission.Write);
            else if(acl.equals("WRITE_ACP"))
                list.grantPermission(grantee, Permission.WriteAcp);
            else if(acl.equals("FULL_CONTROL"))
                list.grantPermission(grantee, Permission.FullControl);
        }
        hs3Client.setObjectAcl(bucketName, objectKey, list);
    }


    /**
     * 读取对象，分片读取
     * @param bucketName 桶名
     * @param objectKey 对象key
     * @param localFilePath 本地文件路径
     * @param start 起始位置
     * @param end 结束位置
     * @throws IOException
     */
    public void getObjectByRange(String bucketName,
                                 String objectKey,
                                 String localFilePath,long start,long end) throws IOException
    {
        GetObjectRequest req = new GetObjectRequest(bucketName,objectKey)
                .withRange(start, end);
        S3Object obj = hs3Client.getObject(req);
        S3ObjectInputStream s3i = obj.getObjectContent();

        FileOutputStream localFile
                = new FileOutputStream(localFilePath);

        byte readBuffer[] = new byte[2048];
        int bufferSize;
        while (-1 != (bufferSize= s3i.read(readBuffer)))
        {
            localFile.write(readBuffer, 0, bufferSize);
        }
        localFile.close();
    }

    /**
     * 分别读取每个版本，保存到本地
     * @param bucketName 桶名
     * @param objectKey 对象key
     * @param dirPath  本地目录
     * @throws IOException
     */
    public void getObjectVersions(String bucketName,
                                  String objectKey,
                                  String dirPath) throws IOException
    {
        //得到各版本
        List<S3VersionSummary> versions =  listVersions(bucketName,objectKey);
        //分别读取每个版本，保存到本地
        for(S3VersionSummary v:versions)
        {
            getObjectVersion(bucketName,v.getKey(),
                    dirPath+"/"+v.getVersionId()+"_"+v.getKey(),v.getVersionId());
        }
    }


    /**
     * 得到指定对象的版本
     * @param bucketName
     * @param objectKey
     * @param localFilePath
     * @param versionId 对象版本id
     * @throws IOException
     */
    public void getObjectVersion(String bucketName,
                                 String objectKey,
                                 String localFilePath,String versionId) throws IOException
    {
        GetObjectRequest req = new GetObjectRequest(bucketName,objectKey).withVersionId(versionId);
        S3Object obj = hs3Client.getObject(req);
        S3ObjectInputStream s3i = obj.getObjectContent();

        FileOutputStream localFile
                = new FileOutputStream(localFilePath);

        byte readBuffer[] = new byte[2048];
        int bufferSize;
        while (-1 != (bufferSize= s3i.read(readBuffer)))
        {
            localFile.write(readBuffer, 0, bufferSize);
        }
        localFile.close();
    }

    /**
     * 读取文件写到本地
     * 在版本开启的情况下,如果不指定版本号，读取的是当前版本
     * @param bucketName 桶名
     * @param objectKey 对象key
     * @param localFilePath 本地文件路径
     * @throws IOException
     */
    public void getObject(String bucketName, String objectKey,String localFilePath) throws IOException
    {
        GetObjectRequest req = new GetObjectRequest(bucketName,objectKey);
        S3Object obj = hs3Client.getObject(req);
        S3ObjectInputStream s3i = obj.getObjectContent();

        FileOutputStream localFile
                = new FileOutputStream(localFilePath);

        byte readBuffer[] = new byte[2048];
        int bufferSize;
        while (-1 != (bufferSize= s3i.read(readBuffer)))
        {
            localFile.write(readBuffer, 0, bufferSize);
        }
        localFile.close();
    }


    /**
     * 对象复制
     * 1、可以同一个租户下的不同桶中复制
     * 2、可以在同一个桶中复制
     * 3、用户需要有源桶的read权，有目标桶的write权；
     * 4、如果版本是开启的，不指定版本号，默认复制当前版本；如果指定版本，复制指定的版本号
     * 5、默认情况下源对象的“用户自定义元数据都会被一并复制到目标对象中
     * 当然，在复制的时候你也可以指定一个新的用户自定义元数据，详见（updateObjectMetadata)
     * 或指定一个空的用户自定义元数据，这样就会将用户自定义元数据删除掉，详见（deleteObjectMetadata)
     * @param sourceBucketName
     * @param sourceKey
     * @param destinationBucketName
     * @param destinationKey
     */
    public void copyObject(String sourceBucketName,			String sourceKey,
                           String destinationBucketName,  String destinationKey)
    {
        CopyObjectRequest request =
                new CopyObjectRequest(sourceBucketName, sourceKey,
                        destinationBucketName, destinationKey)
                        .withSourceBucketName(sourceBucketName)
                        .withSourceKey(sourceKey);
        hs3Client.copyObject(request);
    }

    /**
     * 删除空目录
     * @param bucketName
     * @param dir
     */
    public void deleteDir(String bucketName,String dir)
    {
        hs3Client.deleteObject(bucketName, dir);
    }

    /**
     * 删除对象的各版本
     * @param bucketName
     * @param objectKey
     */
    public void deleteObjectByVersion(String bucketName,String objectKey)
    {
        //得到对象的各版本
        List<S3VersionSummary> list = listVersions(bucketName,objectKey);
        for(S3VersionSummary sv:list)
        {
            //个个删除
            DeleteVersionRequest req = new DeleteVersionRequest(bucketName,objectKey,sv.getVersionId());
            hs3Client.deleteVersion(req);
        }

    }

    /**
     * 列出对象各版本
     * @param bucketName 桶名
     * @param objectKey  对象key
     */
    public List<S3VersionSummary> listVersions(String bucketName,String objectKey)
    {
        ListVersionsRequest req = new ListVersionsRequest().
                withBucketName(bucketName).withPrefix(objectKey);
        VersionListing vl = hs3Client.listVersions(req);
        List<S3VersionSummary> list = vl.getVersionSummaries();
        for(S3VersionSummary sv:list)
        {
            System.out.println(sv.getVersionId());
        }
        return list;
    }

    /**
     * 删除多个对象，不指定版本
     * 经测试不支持
     * @param bucketName
     * @param objectKey 可以传入多个对象key
     */
    public void deleteObjects(String bucketName,String... objectKey)
    {
        DeleteObjectsRequest req = new DeleteObjectsRequest(bucketName)
                .withKeys(objectKey);

        hs3Client.deleteObjects(req);
    }

    /**
     * 删除对象,如果版本功能开启
     * 则并不会真正删除
     * @param bucketName
     * @param objectKey
     */
    public void deleteObject(String bucketName,String objectKey)
    {
        DeleteObjectRequest req = new DeleteObjectRequest(bucketName,objectKey);

        hs3Client.deleteObject(req);
    }

    /**
     * 删除对象元数据
     * @param bucketName 桶名
     * @param objectKey 对象key
     * @param newMetadata 要修改的元数据
     */
    public void deleteObjectMetadata(String bucketName,
                                     String objectKey)
    {
        //声明元数据，但是并不赋值，就可以删除
        ObjectMetadata metadata = new ObjectMetadata();

        CopyObjectRequest request = new CopyObjectRequest(bucketName, objectKey, bucketName, objectKey)
                .withSourceBucketName(bucketName)
                .withSourceKey(objectKey)
                .withNewObjectMetadata(metadata);
        hs3Client.copyObject(request);
    }


    /**
     * 修改对象元数据
     * @param bucketName 桶名
     * @param objectKey 对象key
     * @param newMetadata 要修改的元数据
     */
    public void updateObjectMetadata(String bucketName,
                                     String objectKey,ObjectMetadata newMetadata)
    {
        CopyObjectRequest request = new CopyObjectRequest(bucketName, objectKey, bucketName, objectKey)
                .withSourceBucketName(bucketName)
                .withSourceKey(objectKey)
                .withNewObjectMetadata(newMetadata);
        hs3Client.copyObject(request);
    }

    /**
     * 得到对象的用户自定义元数据
     * @param bucketName
     * @param objectKey
     */
    public void getObjectMetadata(String bucketName,String objectKey)
    {
        GetObjectMetadataRequest req = new GetObjectMetadataRequest(bucketName,objectKey);
        ObjectMetadata metadata = hs3Client.getObjectMetadata(req);
        if(metadata!=null)
        {
            //得到用户自定义元数据
            System.out.print("得到用户自定义元数据");
            Map<String, String> map = metadata.getUserMetadata();
            for(Entry<String, String>  entry:map.entrySet())
            {
                System.out.println("key = "+entry.getKey() +" |  value="+entry.getValue());
            }
            //对象的系统元数据
            System.out.println("对象的系统元数据");
            System.out.println("md5 = "+metadata.getContentMD5());
            System.out.println("size = "+metadata.getContentLength());
            System.out.println("size = "+metadata.getLastModified());


        }
    }

    /**
     * 检测对象是否存在，通过listobject方法进行可检测
     * @param bucketName
     * @param objectKey
     */
    public void checkObject(String bucketName,String objectKey)
    {
        ListObjectsRequest req = new ListObjectsRequest().
                withBucketName(bucketName).
                withPrefix(objectKey);
        ObjectListing objectListing = hs3Client.listObjects(req);

        for (S3ObjectSummary objectSummary: objectListing.getObjectSummaries()) {
            if (objectSummary.getKey().equals(objectKey)) {
                System.out.println("yes");
            }
        }
    }

    /**
     * 分页
     * @param bucketName 桶名
     * @param dirName 目录
     * @param pageSize 每页几条
     * @param marker 翻页的标识位如果是第一页，可以不指定；如果是第二页，请指定你得到的第一页的最后一条记录处
     */
    public void listObjectsByDirPagination(String bucketName,
                                           String dirName,
                                           int pageSize,String marker)
    {
        ListObjectsRequest req = new ListObjectsRequest().
                withBucketName(bucketName).
                withDelimiter("/").
                withPrefix(dirName).
                withMaxKeys(pageSize).withMarker(marker);
        ObjectListing objectListing = hs3Client.listObjects(req);

        for (S3ObjectSummary objectSummary
                : objectListing.getObjectSummaries()) {
            System.out.println(" * " + objectSummary.getKey() + " " +
                    "(size = " + objectSummary.getSize() + ")");
        }
        for(String dir:objectListing.getCommonPrefixes())
        {
            System.out.println(" * " + dir);
        }
    }

    /**
     * 按目录列出对象
     * @param bucketName 桶名
     * @param dirName  限定的目录名
     */
    public void listObjectsByDir(String bucketName,String dirName)
    {
        final ListObjectsRequest req = new ListObjectsRequest().
                withBucketName(bucketName).withDelimiter("/").withPrefix(dirName);
        ObjectListing objectListing = hs3Client.listObjects(req);

        for (S3ObjectSummary objectSummary
                : objectListing.getObjectSummaries()) {
            System.out.println(" * " + objectSummary.getKey() + " " +
                    "(size = " + objectSummary.getSize() + ")");
        }
        for(String dir:objectListing.getCommonPrefixes())
        {
            System.out.println(" * " + dir);
        }
    }

    /**
     * 列出桶内所有对象
     * @param bucketName
     */
    public void listObjects(String bucketName)
    {
        final ListObjectsRequest req = new ListObjectsRequest().withBucketName(bucketName);
        ObjectListing objectListing = hs3Client.listObjects(req);
        for (S3ObjectSummary objectSummary
                : objectListing.getObjectSummaries()) {
            System.out.println(" * " + objectSummary.getKey() + " " +
                    "(size = " + objectSummary.getSize() + ")");
        }
    }


    /**
     * 创建目录
     * @param bucketName 桶名
     * @param objectKey 对象key
     */
    public void createDir(String bucketName,String objectKey )
    {
        PutObjectRequest req = new PutObjectRequest(bucketName,objectKey,new ByteArrayInputStream(new byte[0]), null);
        hs3Client.putObject( req);
    }


    /**
     * 创建对象，并同时指定元数据信息
     * @param bucketName
     * @param objectKey
     * @param localFilePath
     * @param metadata
     */
    public void createObjectAndMetadata(String bucketName,
                                        String objectKey,String localFilePath,ObjectMetadata metadata)
    {
        File file = new File(localFilePath);
        PutObjectRequest req = new PutObjectRequest(bucketName,objectKey,file)
                .withMetadata(metadata);
        hs3Client.putObject( req);
    }


    /**
     * 创建对象
     * @param bucketName 桶名
     * @param objectKey  对象的key
     * @param localFilePath 本地文件路径
     */
    public void createObject(String bucketName,String objectKey,String localFilePath)
    {

        File file = new File(localFilePath);
        PutObjectRequest req = new PutObjectRequest(bucketName,objectKey,file);
        hs3Client.putObject( req);
    }

    /**
     * 得到桶的版本配置
     * @param bucketName
     */
    public void getBucketVersion(String bucketName)
    {
        BucketVersioningConfiguration conf =
                hs3Client.getBucketVersioningConfiguration(bucketName);
        System.out.println(conf.getStatus());
    }

    /**
     * 开启/关闭桶的版本功能
     * 	Enabled    Enables versioning for the bucket
     Suspended  Disables versioning for the bucket
     * @param bucketName
     */
    public void setVersionOnOff(String bucketName,String flag)
    {
        BucketVersioningConfiguration configuration =hs3Client.getBucketVersioningConfiguration(bucketName);
        configuration.setStatus(flag);
        //new BucketVersioningConfiguration().withStatus(flag);
        SetBucketVersioningConfigurationRequest
                setBucketVersioningConfigurationRequest =
                new SetBucketVersioningConfigurationRequest(bucketName,configuration);

        hs3Client.setBucketVersioningConfiguration(setBucketVersioningConfigurationRequest);
    }

    /**
     * 设置桶的权限
     * owner的权限，在创建的时时候进行设置
     * owner可以为其它用户设置权限，并且是成功的
     * @param bucketName
     */
    public void setACLForBucket(String bucketName)
    {
        Collection<Grant> grantCollection = new ArrayList<Grant>();

        AccessControlList bucketACL =   hs3Client.getBucketAcl(bucketName);
        bucketACL.getGrants().clear();

        Grant grant0 = new Grant(
                new
                        CanonicalGrantee("83813c7e-dd96-4572-8556-813b6a997ff7"),
                Permission.Write);
        grantCollection.add(grant0);
        bucketACL.getGrants().addAll(grantCollection);

        hs3Client.setBucketAcl(bucketName, bucketACL);

		/*
		AccessControlList bucketACL = new AccessControlList();// hs3Client.getBucketAcl(bucketName);

		bucketACL.grantPermission(
				new CanonicalGrantee("83813c7e-dd96-4572-8556-813b6a997ff7"),
				Permission.Write );
		bucketACL.grantPermission(
				new CanonicalGrantee("83813c7e-dd96-4572-8556-813b6a997ff7"),
				Permission.Read );

		Owner owner = new Owner();
		owner.setDisplayName("netskill");
		owner.setId("83813c7e-dd96-4570-8556-813b6a997ff7");
		bucketACL.setOwner(owner);

		hs3Client.setBucketAcl(bucketName, bucketACL);

		*/
    }


    /**
     * 得到桶的的权限信息
     * @param bucketName
     */
    public void getACLFromBucket(String bucketName)
    {
        AccessControlList bucketACL = hs3Client.getBucketAcl(bucketName);
        Set<Grant>  grants = bucketACL.getGrants();
        for(Grant g:grants)
        {
            System.out.println(g.getPermission().name());
        }
    }

    /**
     * 列出所有桶 == 列出租户下的命名空间
     * 列出当前用户的所有桶
     * 对于HCP来说，如果命名空间没有开启S3协议，在返回的桶列表中就没有值
     */
    public void listBuckets()
    {
        List<Bucket> buckets = hs3Client.listBuckets();
        for (Bucket bucket : buckets) {

            System.out.println(" 名称 =  " + bucket.getName());
            System.out.println(" 创建时间 =  " + bucket.getCreationDate());
            System.out.println(" 所有者 =  " + bucket.getOwner());
            System.out.println(" ------------------------------------ ");
        }
    }

    /**
     * 创建桶==创建HCP的命名空间
     * HCP桶大小默认空间是50GB，必须保证空间足够，否则无法创建成功
     * 创建成为命名空间的所有者
     */
    public void createBucket(String bucketName)
    {
        com.amazonaws.services.s3.model.Bucket bk =
                hs3Client.createBucket(bucketName);

    }


    /**
     * 创建桶，并同时指定ACL
     * @param bucketName
     */
    public void createBucketWithACL(String bucketName)
    {
        CreateBucketRequest createBucketRequest =
                new CreateBucketRequest(bucketName,
                        Region.US_Standard).withCannedAcl(CannedAccessControlList.PublicRead);

        Bucket bk =
                hs3Client.createBucket(createBucketRequest);

    }

    /**
     * 检测桶是否存在
     * @param bucketName
     */
    public void checkBucketExist(String bucketName)
    {
        boolean flag = hs3Client.doesBucketExist(bucketName);
        System.out.println(flag);
    }

}
